'MODE-X Library Include File
'
'Dmitry Brant  [me@dmitrybrant.com]
'http://dmitrybrant.com
'
'Original library source code by Matt Pritchard, with
'modifications and optimizations by Dmitry Brant.
'
'Public domain. No warranty of any kind.


' ===== SCREEN RESOLUTIONS =====
CONST Mode320x200 = 0, Mode320x400 = 1
CONST Mode360x200 = 2, Mode360x400 = 3
CONST Mode320x240 = 4, Mode320x480 = 5
CONST Mode360x240 = 6, Mode360x480 = 7
 
' ===== MODE X SETUP ROUTINES =====
DECLARE FUNCTION SetVirtX% ALIAS "SET_VGA_MODEX" (BYVAL ModeType%, BYVAL MaxXpos%, BYVAL MaxYpos%, BYVAL Pages%)
DECLARE FUNCTION SetModeX% ALIAS "SET_MODEX" (BYVAL Mode%)
 
' ===== BASIC GRAPHICS PRIMITIVES =====
DECLARE SUB ClearScreen ALIAS "CLEAR_VGA_SCREEN" (BYVAL ColorNum%)
DECLARE SUB SetPoint ALIAS "SET_POINT" (BYVAL Xpos%, BYVAL Ypos%, BYVAL ColorNum%)
DECLARE FUNCTION GetPoint% ALIAS "READ_POINT" (BYVAL Xpos%, BYVAL Ypos%)
DECLARE SUB FillBlock ALIAS "FILL_BLOCK" (BYVAL Xpos1%, BYVAL Ypos1%, BYVAL Xpos2%, BYVAL Ypos2%, BYVAL ColorNum%)
DECLARE SUB DrawLine ALIAS "DRAW_LINE" (BYVAL Xpos1%, BYVAL Ypos1%, BYVAL Xpos2%, BYVAL Ypos2%, BYVAL ColorNum%)

' ===== PAGE FLIPPING AND SCROLLING ROUTINES =====
DECLARE SUB SetActivePage ALIAS "SET_ACTIVE_PAGE" (BYVAL PageNo%)
DECLARE FUNCTION GetActivePage% ALIAS "GET_ACTIVE_PAGE"
DECLARE SUB SetVisiblePage ALIAS "SET_DISPLAY_PAGE" (BYVAL PageNo%)
DECLARE FUNCTION GetVisiblePage% ALIAS "GET_DISPLAY_PAGE"
DECLARE SUB SetWindow ALIAS "SET_WINDOW" (BYVAL DisplayPage%, BYVAL XOffset%, BYVAL YOffset%)
DECLARE FUNCTION GetWindowX% ALIAS "GET_X_OFFSET" ()
DECLARE FUNCTION GetWindowY% ALIAS "GET_Y_OFFSET" ()
DECLARE SUB WaitRetrace ALIAS "SYNC_DISPLAY"
 
' ===== TEXT DISPLAY ROUTINES =====
DECLARE SUB GPRINTC (BYVAL CharacterNum%, BYVAL Xpos%, BYVAL Ypos%, BYVAL ColorF%, BYVAL ColorB%)
DECLARE SUB TGPRINTC (BYVAL CharacterNum%, BYVAL Xpos%, BYVAL Ypos%, BYVAL ColorF%)
DECLARE SUB PRINTSTR ALIAS "PRINT_STR" (BYVAL StrSeg%, BYVAL StrOfs%, BYVAL MaxLen%, BYVAL Xpos%, BYVAL Ypos%, BYVAL ColorF%, BYVAL ColorB%)
DECLARE SUB TPRINTSTR ALIAS "TPRINT_STR" (BYVAL StrSeg%, BYVAL StrOfs%, BYVAL MaxLen%, BYVAL Xpos%, BYVAL Ypos%, BYVAL ColorF%)
DECLARE SUB SetDisplayFont ALIAS "SET_DISPLAY_FONT" (SEG FontData AS ANY, BYVAL FontNumber%)
 
' ===== BITMAP (SPRITE) DISPLAY ROUTINES =====
DECLARE SUB DrawBitmap ALIAS "DRAW_BITMAP" (SEG Image AS ANY, BYVAL Xpos%, BYVAL Ypos%, BYVAL xWidth%, BYVAL Height%)
DECLARE SUB TDrawBitmap ALIAS "TDRAW_BITMAP" (SEG Image AS ANY, BYVAL Xpos%, BYVAL Ypos%, BYVAL xWidth%, BYVAL Height%)
 
' ==== VIDEO MEMORY to VIDEO MEMORY COPY ROUTINES =====
DECLARE SUB CopyPage ALIAS "COPY_PAGE" (BYVAL SourcePage%, BYVAL DestPage%)
DECLARE SUB CopyBitmap ALIAS "COPY_BITMAP" (BYVAL SourcePage%, BYVAL x1%, BYVAL y1%, BYVAL x2%, BYVAL y2%, BYVAL DestPage%, BYVAL DestX1%, BYVAL DestY1%)
